#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef double ld;
ll inf = 1e15, mod = 1e9 + 7;
ld eps = 1e-6;
#define all(a) a.begin(), a.end()

ll gcd(ll a, ll b) {
    if (a % b == 0)
        return b;
    return gcd(b, a % b);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll n, q, i, j;
    cin >> n >> q;
    vector<ll> a(n), b(n), it(n);
    for (i = 0; i < n; i++)
        cin >> a[i];
    sort(all(a));
    for (i = 0; i < n; i++)
        cin >> b[i];
    sort(all(b), greater<>());
    vector<ll> p(q);
    map<ll, ll> nq;
    for (i = 0; i < q; i++) {
        cin >> p[i];
        nq[p[i]] = i;
    }
    sort(all(p));
    vector<pair<ll, ll>> ans(q);
    set<pair<ll, ll>> st;
    for (i = 0; i < n; i++)
        st.insert({a[i] * b[0], i});
    p.insert(p.begin(), 0);
    for (i = 1; i <= q; i++) {
        ll in;
        for (j = p[i - 1]; j < p[i]; j++) {
            in = st.begin()->second;
            st.erase(st.begin());
            if (it[in] < n - 1)
                st.insert({a[in] * b[it[in] + 1], in});
        }
        ll g = gcd(a[in], b[it[in]]);
        ans[nq[p[i]]] = {a[in] / g, b[it[in]] / g};
        it[in]++;
    }
    for (auto itt: ans)
        cout << itt.first << ' ' << itt.second << '\n';
}